--- a/Makefile	2018-03-21 19:51:11.711880972 +0100
+++ b/Makefile	2018-03-21 20:51:46.341684595 +0100
@@ -9,6 +9,9 @@
 STRIP        = $(CROSS_PREFIX)strip
 SHLIB        = $(CC) -shared
 STRIPLIB     = $(STRIP) --strip-unneeded
+LDCONFIG     = ldconfig
+PYTHON2      = $(shell type -P python2 || echo ':' 2> /dev/null)
+PYTHON3      = $(shell type -P python3 || echo ':' 2> /dev/null)
 
 CFLAGS	+= -O3 -Wall -pthread
 
@@ -23,7 +26,7 @@
 
 LIB      = $(LIB1) $(LIB2) $(LIB3)
 
-ALL     = $(LIB) x_pigpio x_pigpiod_if x_pigpiod_if2 pig2vcd pigpiod pigs
+ALL     = $(LIB) pig2vcd pigpiod pigs
 
 LL1      = -L. -lpigpio -pthread -lrt
 
@@ -64,22 +67,21 @@
 	$(CC) -o x_pigpiod_if2 x_pigpiod_if2.o $(LL3)
 
 pigpiod:	pigpiod.o $(LIB1)
-	$(CC) -o pigpiod pigpiod.o $(LL1)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o pigpiod pigpiod.o $(LL1)
 	$(STRIP) pigpiod
 
 pigs:		pigs.o command.o
-	$(CC) -o pigs pigs.o command.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o pigs pigs.o command.o
 	$(STRIP) pigs
 
 pig2vcd:	pig2vcd.o
-	$(CC) -o pig2vcd pig2vcd.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o pig2vcd pig2vcd.o
 	$(STRIP) pig2vcd
 
 clean:
 	rm -f *.o *.i *.s *~ $(ALL)
 
 install:	$(ALL)
-	install -m 0755 -d                $(DESTDIR)/opt/pigpio/cgi
 	install -m 0755 -d                $(DESTDIR)$(includedir)
 	install -m 0644 pigpio.h          $(DESTDIR)$(includedir)
 	install -m 0644 pigpiod_if.h      $(DESTDIR)$(includedir)
@@ -92,13 +94,13 @@
 	install -m 0755 pig2vcd           $(DESTDIR)$(bindir)
 	install -m 0755 pigpiod           $(DESTDIR)$(bindir)
 	install -m 0755 pigs              $(DESTDIR)$(bindir)
-	if which python2; then python2 setup.py install; fi
-	if which python3; then python3 setup.py install; fi
+	$(PYTHON2) setup.py install
+	$(PYTHON3) setup.py install
 	install -m 0755 -d                $(DESTDIR)$(mandir)/man1
 	install -m 0644 *.1               $(DESTDIR)$(mandir)/man1
 	install -m 0755 -d                $(DESTDIR)$(mandir)/man3
 	install -m 0644 *.3               $(DESTDIR)$(mandir)/man3
-	ldconfig
+	$(LDCONFIG)
 
 uninstall:
 	rm -f $(DESTDIR)$(includedir)/pigpio.h
